_tables = Dict{Symbol, Tuple{Vararg{Float64}}}(
    :brmm => (0.7, 1.5, 2.1, 2.2, 1.8, 1.1, 0.8),
    :nrem => (0.0, 0.15, 0.50, 0.85, 1.0),
    :drmm => (2.0, 1.4, 1.0, 0.8, 0.7, 0.6, 0.53, 0.5, 0.5, 0.5, 0.5),
    :drpm => (1.0, 1.1, 1.3, 1.6, 2.2, 3.4, 6.0),
    :drfm => (30.0, 2.4, 1.5, 1.2, 1.0, 0.9, 0.8, 0.73, 0.7),
    :drcm => (1.0, 1.1, 1.3, 1.6, 2.1, 3.0),
    :brcm => (1.0, 0.95, 0.8, 0.7, 0.65, 0.65),
    :brfm => (0.0, 0.4, 1.0, 1.8, 3.0),
    :brpm => (1.0, 0.98, 0.95, 0.9, 0.8, 0.65, 0.5),
    :fcm => (2.4, 1.0, 0.6, 0.4, 0.3, 0.2),
    :fpci => (0.5, 1.0, 1.4, 1.7, 1.9, 2.05, 2.2),
    :cipc => (0.02, 0.05, 0.15, 0.3, 0.5, 0.75),
    :fpm => (1.0, 0.95, 0.8, 0.6, 0.4, 0.25, 0.15),
    :polcm => (0.05, 1.0, 3.0, 6.0, 10.0, 15.0),
    :polat => (0.5, 1.0, 2.4, 4.4, 6.8, 9.6, 11.4),
    :cfifr => (1.0, 0.8, 0.5, 0.2, 0.1),
    :qlm => (0.2, 1.0, 2.2, 4.0, 6.0, 8.0),
    :qlc => (2.0, 1.3, 1.0, 0.75, 0.55, 0.45, 0.38, 0.3, 0.25, 0.22, 0.2),
    :qlf => (0.0, 0.2, 1.0, 2.2, 4.0),
    :qlp => (1.5, 1.0, 0.7, 0.5, 0.35, 0.25, 0.2),
)

_ranges = Dict{Symbol, Tuple{Float64, Float64}}(
    :brmm => (0.0, 15.0),
    :nrem => (0.0, 1.0),
    :drmm => (0.0, 5.0),
    :drpm => (0.0, 6.0),
    :drfm => (0.0, 2.0),
    :drcm => (0.0, 5.0),
    :brcm => (0.0, 5.0),
    :brfm => (0.0, 2.0),
    :brpm => (0.0, 6.0),
    :fcm => (0.0, 5.0),
    :fpci => (0.0, 6.0),
    :cipc => (0.0, 5.0),
    :fpm => (0.0, 6.0),
    :polcm => (0.0, 5.0),
    :polat => (0.0, 6.0),
    :cfifr => (0.0, 2.0),
    :qlm => (0.0, 5.0),
    :qlc => (0.0, 5.0),
    :qlf => (0.0, 2.0),
    :qlp => (0.0, 6.0),
)

gettables() = copy(_tables)
getranges() = copy(_ranges)
